<script lang="ts">
import Component from 'vue-class-component';
import { Prop, PropSync } from 'vue-property-decorator';
import type {
  Unit, Pixel, Second, Rect, Point,
} from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Control the player using keys while canvas is in focus
 * * spacebar toggles playing status
 * * backspace resets the player
 */
@Component
export default class BPlayerControlOnKey extends LabelBehavior {
  mounted() {
    this.register('document-keydown', this.onKey);
    this.register('document-shift-keydown', this.onKey);
  }

  onKey(e: KeyboardEvent) {
    const shift = e.shiftKey;
    if (e.key === ' ' && !shift) {
      this.isPlaying = !this.isPlaying;
      e.preventDefault();
    }
    if (e.key === 'Backspace') {
      this.realTimeSync = 0 as Second;
      e.preventDefault();
    }
    if (shift && e.key === 'ArrowLeft' && this.realTimeSync !== null) {
      const scroll = this.pixelUnit
        .fromOnset(this.secondUnit.toOnset((this.realTimeSync - 10) as Second).value);

      if (this.isPlaying && this.shouldScroll(scroll.value)) {
        this.scrollTo({
          x: scroll.value,
          y: 0,
        } as Point);
      }
      this.realTimeSync = (this.realTimeSync - 10) as Second;
    }
    if (shift && e.key === 'ArrowRight' && this.realTimeSync !== null) {
      const scroll = this.pixelUnit
        .fromOnset(this.secondUnit.toOnset((this.realTimeSync + 10) as Second).value);
      if (this.isPlaying && this.shouldScroll(scroll.value)) {
        this.scrollTo({
          x: scroll.value,
          y: 0,
        } as Point);
      }
      this.realTimeSync = (this.realTimeSync + 10) as Second;
    }
  }

  shouldScroll(pos: Pixel): boolean {
    return pos < this.viewRect.x || pos > (this.viewRect.x + this.viewRect.width);
  }

  @Prop()
  pixelUnit!: Unit<Pixel>;

  @Prop()
  secondUnit!: Unit<Second>;

  @PropSync('realTime', { required: false })
  realTimeSync!: Second;

  @PropSync('playing', { required: true })
  isPlaying!: boolean;

  @Prop()
  scrollTo!: ScrollTo;

  @Prop()
  viewRect!: Rect;
}
</script>
